program LoadFli;
{$R+}

uses crt, crtUtil, dos, VGAUtil, MouseUtil;

TYPE
  ImageArray  = array[0..65534] of byte;

VAR
LastImage,
AktImage     : ^ImageArray;
p            : PaletteArr;
AniHeader    : AniHeaderRec;
w,x,y,z,s,t,
x1,x2,y1,y2,
Mx1,Mx2,My1,My2,
InSpeed, Size,
Counter,Switches,
MouseX, MouseY: WORD;
MouseButton,
speed,
AktPic,
AnzPics,
i,j,k,l,m,n,
MultiPixX,
MultiPixY     : BYTE;
ch           : CHAR;
FliFile,
AniFile      : FILE;
FliName,
AniName,
strDummy     : STRING;
FPos,
FSize,
FilePosSecFrame : LONGINT;
putWater,
makeFont,
MultiFile,
NoChanges,
AllOK        : BOOLEAN;
AnzXChars    : BYTE;

PROCEDURE PaintFirstFrame;
BEGIN
  seek(FliFile,$3A0);  { Beginn des ersten Bildes }
  FOR y:=0 TO 199 DO
    BEGIN
      x:=0;
      BlockRead(FliFile,i,1);
      FOR z:=1 TO i DO  { alle Befehle einer X-spalte durchlaufen }
      BEGIN
        BlockRead(FliFile,j,1);
        IF j>128 THEN   { Versch. Farbenreihe }
         FOR w:=1 TO 256-j DO
           BEGIN
            BlockRead(FliFile,k,1);
            putPix(x,y,k);
            INC(x);
           END
        ELSE
          BEGIN         { Farbwiederholung }
            BlockRead(FliFile,k,1);
            FOR w:=1 TO j DO
             BEGIN
               putPix(x,y,k);
               INC(x);
             END;
          END;
      END;
    END;
END;

FUNCTION PaintFurtherFrames : BOOLEAN;
BEGIN
    blockread(FliFile,i,1);   { Zeilenbeginn }
    blockread(FliFile,k,1);
    blockread(FliFile,j,1);   { anz. Zeilen  }
    blockread(FliFile,k,1);
    FOR y:=i TO i+j-1 DO
    BEGIN
      fpos:=FilePos(FliFile);
      x:=0;
      BlockRead(FliFile,i,1);
      FOR z:=1 TO i DO  { alle Befehle einer X-spalte durchlaufen }
      BEGIN
        BlockRead(FliFile,j,1); { Rechtsverschiebung }
        INC(x,j);
        BlockRead(FliFile,j,1);
        IF j>128 THEN   { Farbwiederholung }
         BEGIN
            BlockRead(FliFile,k,1);
            FOR w:=1 TO 256-j DO
             BEGIN
               putPix(x,y,k);
               INC(x);
             END;
          END
        ELSE
         FOR w:=1 TO j DO    { Versch. Farbenreihe }
           BEGIN
            BlockRead(FliFile,k,1);
            putPix(x,y,k);
            INC(x);
           END;
      END;
    END;
END;

PROCEDURE SaveAnim;
BEGIN
  loadImage(0,0,Switches,'fli2ani.tmp',-1,-1);
  WITH AniHeader DO
  BEGIN
    Name:='ANIM';
    Version:=$0102;
    Colors:=8;     { 8 bit=256 Farben }
    Xwidth:=x2-x1+1;
    Ywidth:=y2-y1+1;
    Switches:=0;
    Speed:=InSpeed;
    AnzFrames:=AnzPics;
    FillChar(UnUsed,SizeOf(UnUsed),0);
  END;
  BlockWrite(AniFile,AniHeader,SizeOf(AniHeader));
  BlockWrite(AniFile,p,SizeOf(p));
  for x:=0 to AniHeader.Xwidth-1 do
   for y:=0 to AniHeader.Ywidth-1 do
    LastImage^[(x+y*AniHeader.Xwidth)]:=getPix(x+x1,y+y1);
  BlockWrite(AniFile,LastImage^,AniHeader.Xwidth*AniHeader.Ywidth);
  AktPic:=0;

  REPEAT
   FillChar(AktImage^,SizeOf(AktImage^),0);
   FPos:=FilePos(FliFile);
   IF odd(FPos) THEN blockread(FliFile,i,1);  { dummybyte laden }
   x:=0;
   REPEAT
     blockread(FliFile,i,1);
     blockread(FliFile,j,1);   { size }
     blockread(FliFile,m,1);   { zeroword }
     blockread(FliFile,n,1);
     blockread(FliFile,k,1);
     blockread(FliFile,l,1);   { code }
     IF (k=$FA) AND (l=$F1) THEN   { Empty Deltaframe }
     BEGIN
       seek(FliFile, FilePos(FliFile)+10);
       INC(AktPic);
       INC(x);
       IF x>1 THEN
       BEGIN
         AktImage^[0]:=4;
         BlockWrite(AniFile,AktImage^,4);
         x:=1;
       END;
     END;
   UNTIL (k=$0C) AND (l=$00);
   PaintFurtherFrames;    { nchsten Deltaframe laden }
   Size:=5;  { size : word, start+anzzeile, anzbef/1.zeile : byte }
   i:=0; w:=4;  { aktZeile, Zeiger auf AnzBef/Zeile }
   noChanges:=TRUE;    { noch keine nderungen im Deltaframe }
   REPEAT
     x:=0; z:=0;       { x=posX, z=lastX }
     WHILE (x<AniHeader.Xwidth) DO
     BEGIN
       IF getPix(x+x1,i+y1)<>LastImage^[x+i*AniHeader.Xwidth] THEN
        BEGIN
          IF noChanges THEN    { noch keine nderungen in DeltaFrame }
           BEGIN
             noChanges:=FALSE;
             AktImage^[2]:=i;                 { StartZeile speichern }
           END;
          AktImage^[3]:=i-AktImage^[2]+1;      { AnzZeilen speichern }
          INC(AktImage^[w]);            { Anz Befehle der akt. Zeile }
          AktImage^[Size]:=x-z;                         { rightshift }
          REPEAT
            INC(AktImage^[Size+1]);
            AktImage^[Size+1+AktImage^[Size+1]]:=getPix(x+x1,i+y1);
            INC(x);
          UNTIL (x>=AniHeader.Xwidth)
                OR (getPix(x+x1,i+y1)=LastImage^[x+i*AniHeader.Xwidth]);
          Size:=Size+AktImage^[Size+1]+1+1;
          z:=x;
        END;   { Vernderung }
       INC(x);
     END;      { akt. Zeile durchlaufen }
     INC(i);
     IF NOT noChanges THEN
     BEGIN
       w:=Size;   { neuen Zeiger auf AnzBef/Zeile setzen }
       INC(Size);
     END;
   UNTIL i=AniHeader.Ywidth;
   IF NOT noChanges THEN
    BEGIN
     DEC(Size,AniHeader.Ywidth-(AktImage^[2]+AktImage^[3]-1));
     for x:=0 to AniHeader.Xwidth-1 do   { neue Ausgangsbasis holen }
      for y:=0 to AniHeader.Ywidth-1 do
        LastImage^[(x+y*AniHeader.Xwidth)]:=getPix(x+x1,y+y1);
    END;
   AktImage^[0]:=LO(Size); AktImage^[1]:=HI(Size);
   BlockWrite(AniFile,AktImage^,Size);
  until AktPic=AnzPics;
END;  { SaveAnim }

PROCEDURE MouseCursor(x,y:integer);
var
pX,pY:WORD;
begin
 line(x-7,y,x+7,y,Counter*4);
 line(x,y-7,x,y+7,Counter*4);
 IF x1<>$FFFF THEN
 BEGIN
   IF X>160 THEN pX:=0 ELSE pX:=200;
   IF Y>100 THEN pY:=0 ELSE pY:=170;
   str(x-x1+1:3,strdummy); print(pX,pY,14,30,strdummy+':');
   str(y-y1+1:3,strdummy); print(pX+32,pY,14,30,strdummy);
 END;
end;



BEGIN      { HAUPTPROGRAMM }
IF ExistFile('Fli2Ani.INI') THEN
  BEGIN
  assign(FliFile,'Fli2Ani.INI');
  reset(FliFile,1);
  blockRead(FliFile,FliName,SizeOf(FliName));
  blockRead(FliFile,AniName,SizeOf(AniName));
  close(FliFile);
  END;


CLRSCR;
writeln('Converter from Autodesk-Flic to SuperMikes AnimationFileFormat  v1.3/96');
writeln;
writeln;
writeln;
REPEAT
  write('Fli-File (adding extension FLI)    ['+FliName+']: ');
  readln(strDummy);
  IF strDummy='' THEN strDummy:=FliName;
UNTIL ExistFile(strDummy+'.FLI');
FliName:=strDummy;
writeln;
write('Ani-File (adding extension ANI or Axx)    ['+AniName+']: ');
readln(strDummy);
IF strDummy='' THEN strDummy:=AniName
ELSE
  AniName:=strDummy;

assign(FliFile,'Fli2Ani.INI');
rewrite(FliFile,1);
blockWrite(FliFile,FliName,SizeOf(FliName));
blockWrite(FliFile,AniName,SizeOf(AniName));
close(FliFile);

writeln;
write('DelayTimeBetweenFrames[10]: ');
readln(strDummy);
VAL(strDummy,inSpeed,x);
if inSpeed=0 THEN inSpeed:=10;
writeln;

putWater:=FALSE;
makeFont:=FALSE;
write('split selected frame into more Animations? '); readln(strDummy);
UpCaseString(strDummy);
IF (strDummy='J') OR (strDummy='Y') THEN
BEGIN
  multiFile:=TRUE;
  x:=16; y:=8;    { default }
  write('horizontal PixelSize ['+LeadingZero(x,2)+']: '); readln(strDummy);  { gridding }
  IF strDummy='' THEN MultiPixX:=x ELSE VAL(strDummy,MultiPixX,x);
  write('vertical PixelSize ['+LeadingZero(y,2)+']: '); readln(strDummy);
  IF strDummy='' THEN MultiPixY:=y ELSE VAL(strDummy,MultiPixY,y);
  writeln;
  write('create Water-PutParts? '); readln(strDummy);
  UpCaseString(strDummy);
  IF (strDummy='J') OR (strDummy='Y') THEN
    BEGIN
    putWater:=TRUE;
    END
  ELSE
    BEGIN
    writeln;
    write('create Font? '); readln(strDummy);
    UpCaseString(strDummy);
    IF (strDummy='J') OR (strDummy='Y') THEN
      BEGIN
      makeFont:=TRUE;
      Writeln; write('Number of Chars in one XRow?[28] '); readln(strDummy);
      VAL(strDummy,AnzXChars,x);
      IF AnzXChars=0 THEN anzXChars:=28;
      END
    ELSE
      AniName:=AniName+'.A';  {just add AA,AB,AC etc. now }
    END
END
ELSE
  AniName:=AniName+'.ANI';
writeln;

FliName:=FliName+'.FLI';
assign(FliFile,FliName);
 {$I-}
 reset(FliFile,1);
 {$I+}
 IF IOresult=0 THEN
 BEGIN
  new(LastImage);
  new(AktImage);
  FSize:=FileSize(FliFile);
  Init320200;
  SetOutPutMode(outputDirectA000h);
  Seek(FliFile,6);
  blockRead(FliFile,AnzPics,1);
  Seek(FliFile,17);
  blockRead(FliFile,speed,1);
  Seek(FliFile,$9B-1);   { Beginn der Palette }
  blockread(FliFile,p,SizeOf(p));
  SetPalette(p);
  PaintFirstFrame;
  FilePosSecFrame:=FilePos(FliFile);
  SaveImage(0,0,319,199,Switches,'fli2ani.tmp');
  x1:=$FFFF; y1:=$FFFF; x2:=$FFFF; y2:=$FFFF;
  Counter:=1; AllOK:=FALSE;

  REPEAT
    GetMouse(MouseX,MouseY,MouseButton);
    if MouseButton>0 then
      if x1=$FFFF then
      begin
        x1:=MouseX;
        y1:=MouseY;
        IF putWater or makeFont THEN AllOk:=TRUE;
      end
      else
       if (x1<>MouseX) or (y1<>MouseY) then
       begin
        IF (x2-x1+1<=$FF) AND (y2-y1+1<=$FF) THEN
        BEGIN
         IF NOT MultiFile THEN
         BEGIN
           x2:=MouseX;
           y2:=MouseY;
           AllOK:=TRUE;
         END
         ELSE
         IF ((MouseX-x1+1) MOD MultiPixX=0)
            AND ((MouseY-y1+1) MOD MultiPixY=0) THEN
         BEGIN
           x2:=MouseX;
           y2:=MouseY;
           AllOK:=TRUE;
         END
          ELSE write(#7,#7,#7);
        END
          ELSE write(#7,#7,#7,#7,#7);
        end;
     if (MouseX<>x2) OR (MouseY<>y2) then
     begin
      loadImage(0,0,Switches,'fli2ani.tmp',-1,-1);
      x2:=MouseX;
      y2:=MouseY;
      end;
     MouseCursor(MouseX,MouseY);
     if x1<>$FFFF then
        rec(x1,y1,MouseX,MouseY,Counter*4);
     inc(counter);
     if Counter=5 then Counter:=1;
     if keypressed then
     begin
      ch:=readkey;
      if (ch=#27) and (x1<>$FFFF) then
      begin
        x1:=$FFFF; { Markierung zurcknehmen }
        y1:=$FFFF;
        ch:=#0;
        loadImage(0,0,Switches,'fli2ani.tmp',-1,-1);
      end;
  end;
  UNTIL AllOK OR (ch=#27);
IF ch<>#27 THEN
BEGIN
  IF putWater THEN
  BEGIN
  IF x1>x2 THEN BEGIN i:=x1; x1:=x2; x2:=i; END;
  IF y1>y2 THEN BEGIN i:=y1; y1:=y2; y2:=i; END;
  END;

IF NOT MultiFile THEN
BEGIN
  assign(AniFile,AniName);
  ReWrite(AniFile,1);
  SaveAnim;
  close(AniFile);
END
ELSE   { MultiFiling }
IF putWater THEN
  BEGIN
  Mx1:=X1; Mx2:=x2;
  My1:=y1; My2:=y2;
  FOR s:=0 TO 2 DO
    FOR t:=0 TO 2 DO
    BEGIN
     Assign(AniFile,AniName+Dec2Hex(s+t*3+1,1)+'.AAA');
     ReWrite(AniFile,1);
     x1:=Mx1+s+s*MultiPixX;
     y1:=My1+t+t*MultiPixY;
     x2:=Mx1+s+s*MultiPixX+MultiPixX-1;
     y2:=My1+t+t*MultiPixY+MultiPixY-1;
     SaveAnim;
     close(AniFile);
     Seek(FliFile,FilePosSecFrame);
{     recFill(x1,y1,x2,y2,13);
     readln;
 }   END;
  FOR s:=0 TO 1 DO
    FOR t:=0 TO 2 DO
    BEGIN
     Assign(AniFile,AniName+Dec2Hex(s+t*2+10,1)+'.AAA');
     ReWrite(AniFile,1);
     x1:=Mx1+3+s+(3+s)*MultiPixX;
     y1:=My1+t+t*MultiPixY;
     x2:=Mx1+3+s+(3+s)*MultiPixX+MultiPixX-1;
     y2:=My1+t+t*MultiPixY+MultiPixY-1;
     SaveAnim;
     close(AniFile);
     Seek(FliFile,FilePosSecFrame);
  {   recFill(x1,y1,x2,y2,23);
     readln;
   } END;
  END
ELSE
  IF makeFont THEN
    BEGIN
    Mx1:=X1; Mx2:=x2;
    My1:=y1; My2:=y2;
    FOR s:=0 TO AnzXChars-1 DO
      FOR t:=0 TO ((256-32) DIV AnzXChars)-1 DO  { Y-Zeilen }
    BEGIN
     Assign(AniFile,AniName+'.F'+Dec2Hex(s+t*AnzXChars +32,2));
     ReWrite(AniFile,1);
     x1:=Mx1+s+s*MultiPixX;
     y1:=My1+t+t*MultiPixY;
     x2:=Mx1+s+s*MultiPixX+MultiPixX-1;
     y2:=My1+t+t*MultiPixY+MultiPixY-1;
     SaveAnim;
     close(AniFile);
     Seek(FliFile,FilePosSecFrame);
     recFill(x1,y1,x2,y2,13);
{     readln;
 }   END;
    END
  ELSE  { normal MultiFiling }
    BEGIN
    Mx1:=X1; Mx2:=x2;
    My1:=y1; My2:=y2;
    FOR s:=0 TO ((Mx2-Mx1+1) DIV MultiPixX) -1 DO
      FOR t:=0 TO ((My2-My1+1) DIV MultiPixY) -1 DO
        BEGIN
        Assign(AniFile,AniName+CHR(s+65)+CHR(t+65));
        ReWrite(AniFile,1);
        x1:=Mx1+s*MultiPixX;
        y1:=My1+t*MultiPixY;
        x2:=Mx1+s*MultiPixX+MultiPixX-1;
        y2:=My1+t*MultiPixY+MultiPixY-1;
        SaveAnim;
        close(AniFile);
        Seek(FliFile,FilePosSecFrame);
        END;
    END;

END;   { ESC bei Bereichsdefinition }
  dispose(LastImage);
  dispose(AktImage);
  close(FliFile);
  Assign(AniFile,'fli2ani.tmp');
  erase(AniFile);

  IF ch<>#27 THEN
    BEGIN
    RecFill(0,0,319,199,0);
    IF NOT MultiFile THEN
      LoadAnim(0,0,1,AniName,0,$FF)
    ELSE
      IF putWater THEN
       Print(0,0,23,55,'water-Parts saved...')
      ELSE
      IF makeFont THEN
       Print(0,0,23,55,'Font-Chars saved...')
      ELSE
       FOR s:=0 TO ((Mx2-Mx1+1) DIV MultiPixX) -1 DO
        FOR t:=0 TO ((My2-My1+1) DIV MultiPixY) -1 DO
          BEGIN
           LoadFirstAnimFrame(s*MultiPixX,t*MultiPixY,1,AniName+CHR(s+65)+CHR(t+65),0,$FF);
      {     LoadAnim(s*MultiPixX,t*MultiPixY,1,AniName+CHR(s+65)+CHR(t+65),0,$FF);
            write(#7);
            ch:=readkey;
      }    END;
    write(#7);
    ch:=readkey;
    END
  ELSE
    FehlerSound;
  textmode (CO80);
 END   { Datei vorhanden }
  ELSE
   Writeln(#7,'Datei nicht gefunden!!!! ');

END.