program Fli2Img;
{$R+}

uses crt, CrtUtil, dos, VGAUtil, MouseUtil;

TYPE
  ImageArray  = array[0..65534] of byte;

VAR
LastImage,
AktImage     : ^ImageArray;
p            : PaletteArr;
AniHeader    : AniHeaderRec;
u,w,x,y,z,
x1,x2,y1,y2,
InSpeed, Size,
Counter,Switches,
MouseX, MouseY: WORD;
MouseButton,
speed,
AktPic,
AnzPics,
i,j,k,l,m,n,
MultiPixX,
MultiPixY    : BYTE;
ch           : CHAR;
FliFile,
ImgFile      : FILE;
FliName,
ImgName,
strDummy     : STRING;
FPos,
FSize        : LONGINT;
vehicleParts,
putWater,
MultiFile,
NoChanges,
AllOK        : BOOLEAN;

PROCEDURE PaintFirstFrame;
BEGIN
  seek(FliFile,$3A0);  { Beginn des ersten Bildes }
  FOR y:=0 TO 199 DO
    BEGIN
      x:=0;
      BlockRead(FliFile,i,1);
      FOR z:=1 TO i DO  { alle Befehle einer X-spalte durchlaufen }
      BEGIN
        BlockRead(FliFile,j,1);
        IF j>128 THEN   { Versch. Farbenreihe }
         FOR w:=1 TO 256-j DO
           BEGIN
            BlockRead(FliFile,k,1);
            putPix(x,y,k);
            INC(x);
           END
        ELSE
          BEGIN         { Farbwiederholung }
            BlockRead(FliFile,k,1);
            FOR w:=1 TO j DO
             BEGIN
               putPix(x,y,k);
               INC(x);
             END;
          END;
      END;
    END;
END;

FUNCTION PaintFurtherFrames : BOOLEAN;
BEGIN
    blockread(FliFile,i,1);   { Zeilenbeginn }
    blockread(FliFile,k,1);
    blockread(FliFile,j,1);   { anz. Zeilen  }
    blockread(FliFile,k,1);
    FOR y:=i TO i+j-1 DO
    BEGIN
      fpos:=FilePos(FliFile);
      x:=0;
      BlockRead(FliFile,i,1);
      FOR z:=1 TO i DO  { alle Befehle einer X-spalte durchlaufen }
      BEGIN
        BlockRead(FliFile,j,1); { Rechtsverschiebung }
        INC(x,j);
        BlockRead(FliFile,j,1);
        IF j>128 THEN   { Farbwiederholung }
         BEGIN
            BlockRead(FliFile,k,1);
            FOR w:=1 TO 256-j DO
             BEGIN
               putPix(x,y,k);
               INC(x);
             END;
          END
        ELSE
         FOR w:=1 TO j DO    { Versch. Farbenreihe }
           BEGIN
            BlockRead(FliFile,k,1);
            putPix(x,y,k);
            INC(x);
           END;
      END;
    END;
END;

PROCEDURE MouseCursor(x,y:integer);
var
pX,pY:WORD;
begin
 line(x-7,y,x+7,y,Counter*4);
 line(x,y-7,x,y+7,Counter*4);
 IF x1<>$FFFF THEN
 BEGIN
   IF X>160 THEN pX:=0 ELSE pX:=200;
   IF Y>100 THEN pY:=0 ELSE pY:=170;
   str(x-x1+1:3,strdummy); print(pX,pY,14,30,strdummy+':');
   str(y-y1+1:3,strdummy); print(pX+32,pY,14,30,strdummy);
 END;
end;

PROCEDURE PrepForFurtherFrame;
BEGIN
   FillChar(AktImage^,SizeOf(AktImage^),0);
   FPos:=FilePos(FliFile);
   IF odd(FPos) THEN blockread(FliFile,i,1);  { dummybyte laden }
   x:=0;
   REPEAT
     blockread(FliFile,i,1);
     blockread(FliFile,j,1);   { size }
     blockread(FliFile,m,1);   { zeroword }
     blockread(FliFile,n,1);
     blockread(FliFile,k,1);
     blockread(FliFile,l,1);   { code }
     IF (k=$FA) AND (l=$F1) THEN   { Empty Deltaframe }
     BEGIN
       seek(FliFile, FilePos(FliFile)+10);
       INC(AktPic);
       INC(x);
       IF x>1 THEN
       BEGIN
         AktImage^[0]:=4;
         x:=1;
       END;
     END;
   UNTIL (k=$0C) AND (l=$00);
   PaintFurtherFrames;    { nchsten Deltaframe laden }
   Size:=5;  { size : word, start+anzzeile, anzbef/1.zeile : byte }
   i:=0; w:=4;  { aktZeile, Zeiger auf AnzBef/Zeile }
   noChanges:=TRUE;    { noch keine nderungen im Deltaframe }
   REPEAT
     x:=0; z:=0;       { x=posX, z=lastX }
     WHILE (x<AniHeader.Xwidth) DO
     BEGIN
       IF getPix(x+x1,i+y1)<>LastImage^[x+i*AniHeader.Xwidth] THEN
        BEGIN
          IF noChanges THEN    { noch keine nderungen in DeltaFrame }
           BEGIN
             noChanges:=FALSE;
             AktImage^[2]:=i;                 { StartZeile speichern }
           END;
          AktImage^[3]:=i-AktImage^[2]+1;      { AnzZeilen speichern }
          INC(AktImage^[w]);            { Anz Befehle der akt. Zeile }
          AktImage^[Size]:=x-z;                         { rightshift }
          REPEAT
            INC(AktImage^[Size+1]);
            AktImage^[Size+1+AktImage^[Size+1]]:=getPix(x+x1,i+y1);
            INC(x);
          UNTIL (x>=AniHeader.Xwidth)
                OR (getPix(x+x1,i+y1)=LastImage^[x+i*AniHeader.Xwidth]);
          Size:=Size+AktImage^[Size+1]+1+1;
          z:=x;
        END;   { Vernderung }
       INC(x);
     END;      { akt. Zeile durchlaufen }
     INC(i);
     IF NOT noChanges THEN
     BEGIN
       w:=Size;   { neuen Zeiger auf AnzBef/Zeile setzen }
       INC(Size);
     END;
   UNTIL i=AniHeader.Ywidth;
   IF NOT noChanges THEN
    BEGIN
     DEC(Size,AniHeader.Ywidth-(AktImage^[2]+AktImage^[3]-1));
     for x:=0 to AniHeader.Xwidth-1 do   { neue Ausgangsbasis holen }
      for y:=0 to AniHeader.Ywidth-1 do
        LastImage^[(x+y*AniHeader.Xwidth)]:=getPix(x+x1,y+y1);
    END;
   AktImage^[0]:=LO(Size); AktImage^[1]:=HI(Size);
END;



BEGIN      { HAUPTPROGRAMM }
IF ExistFile('Fli2Img.INI') THEN
  BEGIN
  assign(FliFile,'Fli2Img.INI');
  reset(FliFile,1);
  blockRead(FliFile,FliName,SizeOf(FliName));
  blockRead(FliFile,ImgName,SizeOf(ImgName));
  close(FliFile);
  END;


CLRSCR;
writeln('Converter from Autodesk-Flic to SuperMikes ImageFileFormat  v1.3/96');
writeln;
writeln;
writeln;
REPEAT
  write('Fli-File (adding extension FLI)    ['+FliName+']: ');
  readln(strDummy);
  IF strDummy='' THEN strDummy:=FliName;
UNTIL ExistFile(strDummy+'.FLI');
FliName:=strDummy;
writeln;
write('Img-File (adding extension IMG or Ixx)    ['+ImgName+']: ');
readln(strDummy);
IF strDummy='' THEN strDummy:=ImgName
  ELSE
  ImgName:=strDummy;

assign(FliFile,'Fli2Img.INI');
rewrite(FliFile,1);
blockWrite(FliFile,FliName,SizeOf(FliName));
blockWrite(FliFile,ImgName,SizeOf(ImgName));
close(FliFile);

putWater:=FALSE;
vehicleParts:=FALSE;
writeln;
write('split selected frame into more Images? '); readln(strDummy);
UpCaseString(strDummy);
IF (strDummy='J') OR (strDummy='Y') THEN
BEGIN
  multiFile:=TRUE;
  x:=16; y:=8;    { default }
  write('horizontal PixelSize ['+LeadingZero(x,2)+']: '); readln(strDummy);  { gridding }
  IF strDummy='' THEN MultiPixX:=x ELSE VAL(strDummy,MultiPixX,x);
  write('vertical PixelSize ['+LeadingZero(y,2)+']: '); readln(strDummy);
  IF strDummy='' THEN MultiPixY:=y ELSE VAL(strDummy,MultiPixY,y);
  writeln;
  write('create Water-PutParts? '); readln(strDummy);
  UpCaseString(strDummy);
  IF (strDummy='J') OR (strDummy='Y') THEN
    putWater:=TRUE
  ELSE
    ImgName:=ImgName+'.I';  {just add AA,AB,BB etc. now }
END
ELSE
  BEGIN
  writeln;
  write('create VehicleSights? '); readln(strDummy);
  UpCaseString(strDummy);
  IF (strDummy='J') OR (strDummy='Y') THEN
      VehicleParts:=TRUE
  ELSE
     ImgName:=ImgName+'.IMG';
  END;
writeln;

FliName:=FliName+'.FLI';
assign(FliFile,FliName);
 {$I-}
 reset(FliFile,1);
 {$I+}
 IF IOresult=0 THEN
 BEGIN
  new(LastImage);
  new(AktImage);
  FSize:=FileSize(FliFile);
  Init320200;
  SetOutPutMode(outputDirectA000h);
  Seek(FliFile,6);
  blockRead(FliFile,AnzPics,1);
  Seek(FliFile,17);
  blockRead(FliFile,speed,1);
  Seek(FliFile,$9B-1);   { Beginn der Palette }
  blockread(FliFile,p,SizeOf(p));
  SetPalette(p);
  PaintFirstFrame;
  AktPic:=0;
  SaveImage(0,0,319,199,Switches,'Fli2Img.tmp');
  x1:=$FFFF; y1:=$FFFF; x2:=$FFFF; y2:=$FFFF;
  Counter:=1; AllOK:=FALSE;

  REPEAT
    GetMouse(MouseX,MouseY,MouseButton);
    if MouseButton>0 then
      if x1=$FFFF then
      begin
        x1:=MouseX;
        y1:=MouseY;
        IF putWater THEN AllOk:=TRUE;
      end
      else
       if (x1<>MouseX) or (y1<>MouseY) then
       begin
         IF NOT MultiFile THEN
         BEGIN
           x2:=MouseX;
           y2:=MouseY;
           AllOK:=TRUE;
         END
         ELSE
         IF ((MouseX-x1+1) MOD MultiPixX=0)
            AND ((MouseY-y1+1) MOD MultiPixY=0) THEN
         BEGIN
           x2:=MouseX;
           y2:=MouseY;
           AllOK:=TRUE;
         END
          ELSE write(#7,#7,#7);
        end;
     if (MouseX<>x2) OR (MouseY<>y2) then
     begin
      loadImage(0,0,Switches,'Fli2Img.tmp',-1,-1);
      x2:=MouseX;
      y2:=MouseY;
      end;
     MouseCursor(MouseX,MouseY);
     if x1<>$FFFF then
        rec(x1,y1,MouseX,MouseY,Counter*4);
     inc(counter);
     if Counter=5 then Counter:=1;
     if keypressed then
     begin
      ch:=readkey;
      if (ch=#27) and (x1<>$FFFF) then
      begin
        x1:=$FFFF; { Markierung zurcknehmen }
        y1:=$FFFF;
        ch:=#0;
        loadImage(0,0,Switches,'Fli2Img.tmp',-1,-1);
      end;
      if (ch=#0) then
      begin
        ch:=readkey;
        IF (ch=#77) AND NOT VehicleParts THEN { cursor left }
        BEGIN
          loadImage(0,0,Switches,'Fli2Img.tmp',-1,-1);
          IF aktPic>=anzPics-1 THEN
            BEGIN
            aktPic:=0;
            PaintFirstFrame;
            END
          ELSE
            PrepForFurtherFrame;
          x1:=$FFFF; { Markierung zurcknehmen }
          y1:=$FFFF;
          ch:=#0;
          SaveImage(0,0,319,199,Switches,'fli2img.tmp');
        END;
      end;
  end;
  UNTIL AllOK OR (ch=#27);
IF ch<>#27 THEN
BEGIN
  IF putWater THEN
  BEGIN
  IF x1>x2 THEN BEGIN i:=x1; x1:=x2; x2:=i; END;
  IF y1>y2 THEN BEGIN i:=y1; y1:=y2; y2:=i; END;
  END;
  loadImage(0,0,Switches,'Fli2Img.tmp',-1,-1);
  IF NOT MultiFile THEN
    IF VehicleParts THEN
      FOR u:=0 TO 23 DO
        BEGIN
        SaveImage(x1,y1,x2,y2,Switches,ImgName+CHR(65+u)+'.IMG');
          IF aktPic>=anzPics-1 THEN
            BEGIN
            aktPic:=0;
            PaintFirstFrame;
            END
          ELSE
            PrepForFurtherFrame;
        END
    ELSE
      SaveImage(x1,y1,x2,y2,Switches,ImgName)
  ELSE
    IF NOT putWater THEN
      FOR j:=0 TO ((x2-x1+1) DIV MultiPixX) -1 DO
        FOR i:=0 TO ((y2-y1+1) DIV MultiPixY) -1 DO
          SaveImage(x1+j*MultiPixX,y1+i*MultiPixY,
            x1+j*MultiPixX+MultiPixX-1,y1+i*MultiPixY+MultiPixY-1,
            Switches,ImgName+CHR(j+65)+CHR(i+65))
    ELSE
      BEGIN
      FOR j:=0 TO 2 DO
        FOR i:=0 TO 2 DO
          BEGIN
          SaveImage(x1+j*MultiPixX+j,y1+i*MultiPixY+i,
            x1+j+j*MultiPixX+MultiPixX-1,y1+i+i*MultiPixY+MultiPixY-1,
            Switches,ImgName+Dec2Hex(j+i*3+1,1)+'.IAA');
{          RecFill(x1+j*MultiPixX+j,y1+i*MultiPixY+i,
            x1+j+j*MultiPixX+MultiPixX-1,y1+i+i*MultiPixY+MultiPixY-1,
            13);
          readln;
 }         END;
      FOR j:=0 TO 1 DO
        FOR i:=0 TO 2 DO
          BEGIN
          SaveImage(x1+(3+j)*MultiPixX+3+j,y1+i*MultiPixY+i,
            x1+j+3+(3+j)*MultiPixX+MultiPixX-1,y1+i+i*MultiPixY+MultiPixY-1,
            Switches,ImgName+Dec2Hex(j+i*2+10,1)+'.IAA');
  {        RecFill(x1+(3+j)*MultiPixX+3+j,y1+i*MultiPixY+i,
            x1+j+3+(3+j)*MultiPixX+MultiPixX-1,y1+i+i*MultiPixY+MultiPixY-1,
            26);
          readln;
   }       END;
      END;
END;   { ESC bei Bereichsdefinition }
  dispose(LastImage);
  dispose(AktImage);
  close(FliFile);
  Assign(ImgFile,'Fli2Img.tmp');
  erase(ImgFile);

  IF ch<>#27 THEN
    BEGIN
    RecFill(0,0,319,199,0);
    IF NOT MultiFile THEN
     IF vehicleParts THEN
        Print(0,0,23,55,'Vehicle-Sights saved...')
     ELSE
      LoadImage(0,0,Switches,ImgName,0,$FF)
    ELSE
     IF NOT putWater THEN
          LoadImage(0,0,Switches,ImgName,0,$FF)
     ELSE
       Print(0,0,23,55,'water-Parts saved...');
    write(#7);
    repeat until keypressed;
    END
  ELSE
    FehlerSound;
   textmode (CO80);
 END   { Datei vorhanden }
  ELSE
   Writeln(#7,'Datei nicht gefunden!!!! ');

END.